/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: arm.c 2410 2012-08-30 08:22:53Z ertl-honda $
 */

#include "kernel_impl.h"

#if (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7)
/*
 *  Då򳫻
 */
void
dcache_enable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);

	/* ǤONʤ꥿ */
	if (bits & CP15_CONTROL_C_BIT){
		return;
	}

	dcache_invalidate();

	bits |= CP15_CONTROL_C_BIT;
	CP15_CONTROL_WRITE(bits);
}

/*
 *  Dåߤ̵Ȥ롥
 *  CA9ǤϡDå夬̵ʾ֤Clean and Invalidate()¹Ԥȡ
 *  ˽뤿ᡤDåξ֤ȽǤơ̵ʾϡInvalidate
 *  ΤߤԤ 
 */
void
dcache_disable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);
	if( bits & CP15_CONTROL_C_BIT ){
		bits &= ~CP15_CONTROL_C_BIT;
		CP15_CONTROL_WRITE(bits);
		dcache_clean_and_invalidate();
	}
	else{
		dcache_invalidate();
	}
}

/*
 *  Iåγ
 */
void
icache_enable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);

	/*
	 *  Ǥͭʤ꥿
	 */
	if(bits & CP15_CONTROL_I_BIT){
		return;
	}

	icache_invalidate();

	bits |= CP15_CONTROL_I_BIT;
	CP15_CONTROL_WRITE(bits);
}

/*
 *  Iå
 */
void
icache_disable(void)
{
	uint32_t bits;

	CP15_CONTROL_READ(bits);
	bits &= ~CP15_CONTROL_I_BIT;
	CP15_CONTROL_WRITE(bits);

	icache_invalidate();
}

/*
 *  I/Dåξͭ
 */
void
cache_enable(void)
{
	dcache_enable();
	icache_enable();
}

/*
 *  I/Dåξ̵
 */
void
cache_disable(void)
{
	dcache_disable();
	icache_disable();
}

/*
 *  MMUϢΥɥ饤
 */
#define DOMAIN_NO  1
#define SIZE_1M    0x00100000
#define PAGE_TABLE_SIZE  0x00004000 /* 4KB */

/*
 * ڡơ֥
 */
static uint8_t PageTable[PAGE_TABLE_SIZE]  __attribute__ ((aligned (0x4000)));

/*
 * ˽,Υޥåԥ󥰤Ԥ
 * ޥåԥ󥰤ñ̤1MB 
 */
void
mmu_map_memory(MEMORY_ATTRIBUTE *m_attribute)
{
	uint32_t size;
	uintptr_t va;
	uintptr_t pa;
	uint32_t ttb;
	uint32_t *sptr;
	uint32_t fix_val;
	
	size = m_attribute->size;
	va   = m_attribute->va;
	pa   = m_attribute->pa;

	/* MBñ̤ˤʤ褦˥ */
	size = (size + 0x000FFFFF) & ~0x000FFFFF;

	/*
	 * ڡơ֥Υ١ɥ쥹
	 */
	CP15_TTB0_READ(ttb);

	fix_val =  (m_attribute->s << 16) | (m_attribute->tex << 12) | (m_attribute->ap << 10)
		        | (m_attribute->c << 3) | (m_attribute->b << 2) | (1 << 1);
#if __TARGET_ARCH_ARM == 7
	fix_val |= (m_attribute->ns << 19);
#endif /* __TARGET_ARCH_ARM == 7 */
	sptr  = (uint32_t *)((ttb & 0xFFFFC000) | (((va & 0xFFF00000) >> 20) << 2));

	while(size > 0) {
		*sptr = pa | fix_val;

		sptr++;
		va   += SIZE_1M;
		pa   += SIZE_1M;
		size -= SIZE_1M;
	}
}

/*
 *  MMUν
 */
void
mmu_init(void)
{
	uint32_t bits = 0;

	/* ץեåХåե򥯥ꥢ */
	pbuffer_flash();

	/* TTBR0Ѥ褦˻ */
	CP15_TTBCR_WRITE(0);

	/*
	 * Ѵơ֥(TT)ȤơPageTableѤ
	 * SharedӥåȤ򥻥å
	 */
#if __TARGET_ARCH_ARM == 6
	CP15_TTB0_WRITE((((uintptr_t)PageTable)|CP15_TTB0_RGN_S|CP15_TTB0_RGN_WBWA));
#else /* __TARGET_ARCH_ARM == 7 */
	CP15_TTB0_WRITE((((uintptr_t)PageTable)|CP15_TTB0_RGN_S|CP15_TTB0_RGN_WBWA|CP15_TTB0_IRGN_WBWA));
#endif /* __TARGET_ARCH_ARM == 7 */

	/* ץեåХåե򥯥ꥢ */
	pbuffer_flash();

	/*
	 *  åȰ¸ǤMMUν
	 */
	target_mmu_init();

	/*
	 * ɥᥤֹ򥻥å
	 */
	CP15_DOMAINS_WRITE(DOMAIN_NO);

	/*
	 *  CONTROLץå MӥåȡXPӥåȤ򥻥åȤơ
	 *  MMUͭˤ
	 */
	CP15_CONTROL_READ(bits);
	bits |= CP15_CONTROL_M_BIT | CP15_CONTROL_XP_BIT;
	CP15_CONTROL_WRITE(bits);
}
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
