/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_kernel.h 2346 2012-04-26 07:15:16Z ertl-honda $
 */

/*
 *      kernel.hΥ¸ARMѡ
 *
 *  Υ󥯥롼ɥեϡtarget_kernel.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_CORE_KERNEL_H
#define TOPPERS_CORE_KERNEL_H

#ifndef TOPPERS_MACRO_ONLY

#include "arm.h"

#if (__TARGET_ARCH_ARM == 4) || (__TARGET_ARCH_ARM == 5)
typedef struct {
	uint32_t nest_count;
	uint32_t ipm;
	uint32_t cpsr;
	uint32_t r0;
	uint32_t r1;
	uint32_t r2;
	uint32_t r3;
	uint32_t r12;
	uint32_t lr;
	uint32_t pc;
} exc_frame_t;
#else /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */
typedef struct {
	uint32_t nest_count;
	uint32_t ipm;
	uint32_t r0;
	uint32_t r1;
	uint32_t r2;
	uint32_t r3;
	uint32_t r12;
	uint32_t lr;
	uint32_t pc;
	uint32_t cpsr;
} exc_frame_t;
#endif /* (__TARGET_ARCH_ARM == 6) || (__TARGET_ARCH_ARM == 7) */


/*
 * CPU㳰襢ɥ쥹μ
 */
Inline uint32_t
x_get_exc_raddr(void *p_excinf)
{
	return(((exc_frame_t *)(p_excinf))->pc);
}

/*
 * CPU㳰襢ɥ쥹
 */
Inline void
x_set_exc_raddr(void *p_excinf, uint32_t pc)
{
	((exc_frame_t *)(p_excinf))->pc = pc;
}

#if __TARGET_ARCH_ARM == 7

/* ǽ¬ѤΥ󥿤Υǡ */
typedef uint32_t PERFCNT;

/*
 *  ѥեޥ󥹥󥿤ν
 */
Inline void
x_init_pcc(void)
{
	uint32_t tmp;
	/* 󥿡ͭ */
	CP15_PMCR_READ(tmp);

#ifdef TOPPERS_ARM_PCC_DIV64
	tmp |= CP15_PMCR_PMCCNTR_D;
#else /* !TOPPERS_ARM_PCC_DIV64 */
	tmp &= ~CP15_PMCR_PMCCNTR_D;
#endif /* TOPPERS_ARM_PCC_DIV64 */

	CP15_PMCR_WRITE(tmp|CP15_PMCR_ALLCNTR_ENABLE);

	/* ѥեޥ󥹥󥿤ͭ */
	CP15_PMCNTENSET_READ(tmp);
	CP15_PMCNTENSET_WRITE(tmp|CP15_PMCNTENSET_CCNTR_ENABLE);
}

/*
 *  ѥեޥ󥹥󥿤ɤ߹
 */
Inline void 
x_get_pcc(PERFCNT *p_count)
{
	CP15_PMCCNTR_READ(*p_count);
}

/*
 *  ѥեޥ󥹥󥿤Υꥻå
 */
Inline void
x_rst_pcc(void)
{
	uint32_t tmp;
	CP15_PMCR_READ(tmp);
	CP15_PMCR_WRITE(tmp|CP15_PMCR_PMCCNTR_CLEAR);
}

/*
 *  ͤnsecؤѴ
 */
Inline ulong_t
x_cnv_nsec(PERFCNT count) {
#ifdef TOPPERS_ARM_PCC_DIV64
	return ((ulong_t)count*(1000/(CORE_CLK_MHZ/64)));
#else /* !TOPPERS_ARM_PCC_DIV64 */
	return ((ulong_t)count*(1000/CORE_CLK_MHZ));
#endif /* TOPPERS_ARM_PCC_DIV64 */
}

#elif __TARGET_ARCH_ARM == 6


#endif /* __TARGET_ARCH_ARM == 7 */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CORE_KERNEL_H */
