/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: gic.h 2409 2012-08-30 08:08:57Z ertl-honda $
 */

/*
 *  ARM Generic Interrupt Controller ɥ饤
 */

#ifndef TOPPERS_GIC_H
#define TOPPERS_GIC_H

#include <sil.h>
#include <arm.h>

/*
 *  CPU Interface
 *
 *  ͥ٤ϡ0x00xF 16ʳ
 *  0x0ǹͥ٤ǡ0xFͥ١
 */
#define GICC_CTLR (GICC_BASE + 0x00)  /* ȥ쥸 */
#define GICC_PMR  (GICC_BASE + 0x04)  /* ͥ٥ޥ쥸 */
#define GICC_BPR  (GICC_BASE + 0x08)  /* Хʥݥȥ쥸 */
#define GICC_IAR  (GICC_BASE + 0x0C)  /* Interrupt Acknowledge Register */
#define GICC_EOIR (GICC_BASE + 0x10)  /* End of Interrupt Register */
#define GICC_RPR  (GICC_BASE + 0x14)  /* Running Interrupt Register */

#define GICC_CTLR_EN      0x01
#define GICC_CTLR_ENABLEGRP0 0x01
#define GICC_CTLR_ENABLEGRP1 0x02
#define GICC_CTLR_CBPR       0x10
#define GICC_CTLR_FIQEn      0x08

#if GIC_PRI_LEVEL == 16
#define GICC_PMR_OFFSET 0x04
#define GICC_PMR_MASK   0x0f
#elif GIC_PRI_LEVEL == 32
#define GICC_PMR_OFFSET 0x03
#define GICC_PMR_MASK   0x1f
#elif GIC_PRI_LEVEL == 64
#define GICC_PMR_OFFSET 0x02
#define GICC_PMR_MASK   0x3f
#elif GIC_PRI_LEVEL == 128
#define GICC_PMR_OFFSET 0x01
#define GICC_PMR_MASK   0x7f
#elif GIC_PRI_LEVEL == 256
#define GICC_PMR_OFFSET 0x00
#define GICC_PMR_MASK   0xff
#else
#error
#endif /* GIC_PRI_LEVEL == 16 */

/*
 *  Distributor
 */
#define GICD_CTLR        (GICD_BASE + 0x0000)  /* ȥ쥸 */
#define GICD_TYPER       (GICD_BASE + 0x0004)  /* Interrupt Controller ץ쥸 */
#define GICD_IIDR        (GICD_BASE + 0x0008)  /* Distributor Implementer ID */
#define GICD_IGROUPRn    (GICD_BASE + 0x0080)  /* ߥƥ */
#define GICD_ISENABLERn  (GICD_BASE + 0x0100)  /* ߥ֥͡륻å   */
#define GICD_ICENABLERn  (GICD_BASE + 0x0180)  /* ߥ֥͡륯ꥢ */
#define GICD_ISPENDRn    (GICD_BASE + 0x0200)  /* ߥåȥڥǥ */
#define GICD_ICPENDRn    (GICD_BASE + 0x0280)  /* ߥꥢڥǥ */
#define GICD_ISACTIVERn  (GICD_BASE + 0x0300)  /* ߥåȥƥ֥쥸 */
#define GICD_IPRIORITYRn (GICD_BASE + 0x0400)  /* ͥ٥쥸 */
#define GICD_ITARGETSRn  (GICD_BASE + 0x0800)  /* ߥåȥ쥸/CA9SPIåȥ쥸 */
#define GICD_ICFGRn      (GICD_BASE + 0x0C00)  /* ߥե졼쥸 */
#define GICD_SGIR        (GICD_BASE + 0x0F00)  /* եȥߥ쥸  */

#define GICD_PPIS        (GICD_BASE + 0x0D00)  /* PPIơ */
#define GICD_SPIS        (GICD_BASE + 0x0D04)  /* SPIơ */

#define GICD_CTLR_ENABLE 0x01

/*
 *  Υץåλ
 */
#define GICD_ITARGETSRn_CPU0  0x01
#define GICD_ITARGETSRn_CPU1  0x02
#define GICD_ITARGETSRn_CPU2  0x04
#define GICD_ITARGETSRn_CPU3  0x08

#define GICD_SGIR_CPU0  0x01
#define GICD_SGIR_CPU1  0x02
#define GICD_SGIR_CPU2  0x04
#define GICD_SGIR_CPU3  0x08
#define GICD_SGIR_CPUS  0x0f

#define GICD_SGIR_CPU_OFFSET 16

/*
 *  ͥ
 */
#define GIC_MAX_PRIORITY  0x00
#define GIC_MIN_PRIORITY  GICC_PMR_MASK

/*
 *  ե졼쥸
 */
#define GICD_ICFGRn_EDGE     0x03   /* å */
#define GICD_ICFGRn_LEVEL    0x00   /* ٥ */
#define GICD_ICFGRn_N_N      0x00   /* N-Nǥ    */
#define GICD_ICFGRn_1_N      0x01   /* 1-Nǥ    */

/*
 *  GICǥݡȤƤ߿
 */
#define GIC_TMIN_INTNO      0U

#ifndef GIC_TMAX_INTNO
#define GIC_TMAX_INTNO    255U
#endif /* GIC_TMAX_INTNO */

#ifndef GIC_TNUM_INT
#define GIC_TNUM_INT      256U
#endif /* GIC_TNUM_INT */

/*
 *  Хߤγֹ
 */
#define TMIN_GLOBAL_INTNO   32U

/*
 * ֹ(GICǤֹ)
 */
#define GIC_IRQNO_IPI0     0
#define GIC_IRQNO_IPI1     1

#ifndef TOPPERS_MACRO_ONLY

/*
 *  GIC CPU Interface ϢΥɥ饤
 */
/*
 *  CPUγͥ٥ޥ
 */ 
Inline void
gicc_set_priority(int pri)
{
	sil_wrw_mem((void *)GICC_PMR,
				(pri << GICC_PMR_OFFSET));
}

/*
 *  CPUγͥ٥ޥ
 */ 
Inline int
gicc_current_priority(void)
{
	return (sil_rew_mem((void *)(GICC_PMR)) >>
			GICC_PMR_OFFSET);    
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
gicc_end_int(uint8_t id)
{
	sil_wrw_mem((void *)(GICC_EOIR), id);
}

/*
 *  GICΥץåγͥ٤ΤɤΥӥåȤѤ뤫
 */
Inline void
gicc_set_bp(int mask_bit)
{
	sil_wrw_mem((void *)GICC_BPR, mask_bit);
}

/*
 *  GIC CPU Interface ν
 */
extern void gicc_init(void);

/*
  *  GIC CPU Interface νλ
 */
extern void gicc_stop(void);

/*
 *  Distributor ϢΥɥ饤
 */

/*
 *  ߶ػ
 */
extern void gicd_disable_int(uint8_t id);

/*
 *  ߵ
 */
extern void gicd_enable_int(uint8_t id);

/*
 *  ߥڥǥ󥰥ꥢ
 */
extern void gicd_clear_pending(uint8_t id);

/*
 *  ߥڥǥ󥰥å
 */
extern void gicd_set_pending(uint8_t id);

/*
 *  ׵Υå
 */
extern bool_t gicd_probe_int(uint8_t id);

/*
 *  Υå
 */
extern void gicd_config(uint8_t id, bool_t is_edge, bool_t is_1_n);

/*
 *  ͥ٤Υå
 *  ɽϤ 
 */
extern void gicd_set_priority(uint8_t id, int pri);

/*
 *  ߥåȤ
 *  CPUORǻ  
 */
extern void gicd_set_target(uint8_t id, uint8_t cpus);

/*
 *  Ditoributor ν
 */
extern void gicd_init(void);

/*
 *  Ditoributor ννλ
 */
extern void gicd_stop(void);

/*
 *  եȥߤȯ
 */
Inline void
gic_raise_sgi(int cpu, int id)
{
	CP15_DATA_SYNC_BARRIER();
	sil_wrw_mem((void *)GICD_SGIR, (cpu << GICD_SGIR_CPU_OFFSET)|id);
	CP15_DATA_SYNC_BARRIER();
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_GIC_H */
