/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: gic_support.S 2486 2013-02-21 14:02:05Z ertl-honda $
 */

/*
 *  GICɥ饤  ֥
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc" 

#if  (__TARGET_ARCH_ARM < 6)
#error gic_suport.S supports ARMv6 or later.
#endif /*  (__TARGET_ARCH_ARM < 6) */

/*
 * ߥϥɥ
 */
	ATEXT
	AALIGN(2)
	AGLOBAL(irq_handler)
ALABEL(irq_handler)
	/* 
	 * IRQ⡼ɤǼ¹Ԥ
	 */
	sub   lr, lr, #4 /* 襢ɥ쥹  */

	/* 
	 * lr() spsr(cpsr_svc)򥹡ѡХ⡼ɤΥå
	 * ¸
	 */
	srsdb #CPSR_SVC! 

	/*
	 *  Υ⡼(ѡХ⡼)
	 *  ܹԤƥȤ¸
	 */
	msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)
	stmfd sp!, {r0-r3,ip,lr}

	/*
	 *  װȽꡥ
	 */
	ldr   r2, =(GICC_IAR)
	ldr   r12, [r2]
	mov   r1, r12, lsl #22  /* 10ӥåȰʳ򥯥ꥢ */
	mov   r1, r1, lsr #22

	/*
	 *  spurious(INT_ID=1023(0x03ff))ξ硤߽λ 
	 */
	ldr   r2, =(0x03ff)
	cmp   r2, r1
	ldreq r2,=GICC_EOIR
	streq r12,[r2]                /* EOI쥸ؤν񤭹 */
	beq   ret_int_1

#ifdef TOPPERS_SAFEG_SECURE
	/*
	 *  ߥ롼פ򥵥ݡȤƤ(INT_ID=1022(0x03fe))spurious
	 */
	ldr   r2, =(0x03fe)
	cmp   r2, r1
	bne   irq_handler_0
	bl    check_spurious_1022
	ldr   r2, =(0x03fe)
	cmp   r2, r0
	beq   ret_int_1
	mov   ip, r0
	mov   r1, r0

irq_handler_0:
#endif /* TOPPERS_SAFEG_SECURE */
	mov   lr, sp       /* λΥåΤ */

	/*
	 *  ¿ųߤȽ
	 */
	ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
	ldr   r3, [r2]
	add   r0,r3,#1              /* 㳰ߥͥȲ򹹿 */
	str   r0, [r2]
	cmp   r3, #0
	bne   irq_handler_1

	/* 
	 * ܤ㳰ʳߡˤʤ饹åѹ
	 */
	ldr  r0, =_kernel_istkpt
	ldr  sp, [r0]

ALABEL(irq_handler_1)
	stmfd sp!, {lr}  /* ѤΥåݥ󥿤¸ */

	/*
	 *  ߥϥɥΥɥ쥹
	 */
	ldr   r2, =inh_tbl           /* ߥϥɥơ֥ɤ߹ */
	ldr   r0, [r2, r1, lsl #2]   /* r0<-ߥϥɥ */

	/*
	 *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
	 *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
	 *  ¸롥
	 */
	ldr   lr, =(GICC_RPR)
	ldr   r2, [lr]
	ldr   r3, =(GICC_PMR) /* ȯγͥ٥ޥ */
	ldr   lr, [r3]   
	str   r2, [r3]   /* ͥ٥ޥ򥻥åȤ */
	stmfd sp!, {lr}  /* ȯγͥ٥ޥ򥹥å¸ */

	stmfd sp!,{r12}   /* GICC_IAR Ƥ¸  */
	stmfd sp!,{r1}   /* inhno ¸  */

#ifdef TOPPERS_SAFEG_LOAD
	stmfd sp!,{r0}
	bl safeg_load_int
	ldmfd sp!,{r0}
#endif /* TOPPERS_SAFEG_LOAD */

	/* 
	 * ߵ 
	 */
	msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)

#ifdef LOG_INH_ENTER
	stmfd sp!,{r0}
	mov   r0, r1         /* inhno ѥ᡼ */
	bl    log_inh_enter  /* log_inh_enterƤӽФ */
	ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

	/* 
	 * ߥϥɥθƤӽФ
	 */
	mov   lr,  pc
	bx    r0

	ldmfd sp!, {r0}     /* inhno   */
	ldmfd sp!, {r12}     /* GICC_IAR Ƥ¸  */

	ldr   r1, =(GICC_EOIR)  /* EOI쥸ؤν񤭹 */
	str   r12, [r1]

#ifdef LOG_INH_LEAVE
	bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

	/*
	 * ͥγߤػߤ
	 */
	msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)

	/*
	 * ͥ٥ޥ򸵤᤹
	 */
	ldmfd sp!,{r1}                /* γͥ٥ޥ */
	ldr   r0, =(GICC_PMR)         /* GIC˥å */
	str   r1, [r0]

	/*
	 * åݥ󥿤
	 */
	ldmfd sp!,{r2}        /* Υåݥ󥿤 */
	mov   sp, r2

	/*
	 * νARM¸Ǽ¹
	 */
	b     ret_int

/*
 * åȰ¸㳰
 * ARMv6/7ARMv4ȸƤӽФ郎ۤʤ뤿դ뤳ȡ
 * ѡХ⡼ɤǸƤӽФ롥
 */
	ATEXT
	AGLOBAL(target_exc_handler)
ALABEL(target_exc_handler)
	mov   lr, sp       /* λΥåΤ */

	ldr   r0, =(GICC_PMR) /* 㳰ȯγͥ٥ޥ */
	ldr   r3, [r0]
	asr   r3, r3, #GICC_PMR_OFFSET /* ɽѹ */
	sub   r3, r3, #(GICC_PMR_MASK)
	stmfd sp!, {r3}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

	/* 
	 * ƥȽΤᡤexcpt_nest_count 򥹥å¸
	 * å¸ߤexcpt_nest_count-1ȼǤ뤬
	 * åѤǤǥХåԤ䤹Τǡå
	 * ¸롥
	 */
	ldr   r0, =excpt_nest_count
	ldr   r3, [r0]
	stmfd sp!, {r3}

	mov   r3,  sp   /* 㳰ե졼Ϥ¸ */

	/*
	 * ͥCPU㳰Ƚꤹ
	 * 
	 * ͥCPU㳰ϡͥ¹桤ߥå֡
	 * CPUå֡ͥγߥϥɥ¹ȯ
	 * CPU㳰Ǥ롥ARMξϡSPSRI/Fե饰Τ줫'1'ʤ顤
	 * 롥
	 */
	ldr   r1, [sp, #(9*4)]              /* 㳰ե졼फspsr */
	tst   r1, #(CPSR_FIQ_BIT AOR CPSR_IRQ_BIT) 
	bne   target_kernel_unc_exc_handler /* ͥCPU㳰ν */

	/*
	 *  㳰ȯΥƥȤȽ
	 */
	ldr   r0, =excpt_nest_count
	ldr   r1, [r0]
	add   r1,r1,#1
	str   r1, [r0]
	cmp   r1, #1
	bne   target_exc_handler_1

	/* 
	 * ƥȤCPU㳰ȯ
	 * å󥿥ƥȤڤؤ롥
	 */
	ldr  r0, =_kernel_istkpt
	ldr  sp, [r0]

ALABEL(target_exc_handler_1)
	stmfd sp!, {lr}  /* ѤΥåݥ󥿤¸ */

	/* 
	 * ȯγͥ٥ޥ򥹥å¸ 
	 * ߥϥɥȽи롼ͭ뤿¸
	 */
	ldr   r0, =(GICC_PMR) /* 㳰ȯγͥ٥ޥ */
	ldr   r1, [r0]   
	stmfd sp!, {r1}  /* 㳰ȯγͥ٥ޥ򥹥å¸ */

	/*
	 *  CPU㳰ϥɥεưϤ
	 */
	ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
	ldr   r1, [r0,r2,lsl #2]   /* r1<-㳰ϥɥ */

	stmfd sp!,{r2}    /* excno ¸ */

	/* 
	 * ߵ
	 * CPU㳰ϥɥ̥롼ǸƤӽФᡤñSVC⡼
	 * ˤǤ褤
	 */
	msr cpsr_cxsf, #(CPSR_SVC AOR CPSR_ALWAYS_SET)

#ifdef LOG_EXC_ENTER
	stmfd sp!, {r1, r3}
	mov   r0, r2       /* excno ѥ᡼ */
	bl	log_exc_enter  /* log_exc_enterƤӽФ */
	ldmfd sp!, {r1, r3}
#endif /* LOG_EXC_ENTER */

	/* 
	 * CPU㳰ϥɥθƤӽФ
	 *
	 * 㳰ե졼ƬȤϤ
	 */
	mov   r0,  r3
	mov   lr,  pc
	bx    r1

ALABEL(target_ret_exc)
	ldmfd sp!, {r0}    /* excno   */
#ifdef LOG_EXC_LEAVE
	bl	log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

	/*
	 * ͥγߤػߤ
	 */
	msr   cpsr_cxsf, #(CPSR_SVC AOR CPSR_CPULOCK AOR CPSR_ALWAYS_SET)

	/*
	 * ͥ٥ޥ򸵤᤹
	 */
	ldmfd sp!,{r1}                     /* γͥ٥ޥ */
	ldr   r0, =(GICC_PMR)              /* GIC˥å */
	str   r1, [r0]

	/*
	 * åݥ󥿤
	 */
	ldmfd sp!, {r2}    /* Υåݥ󥿤 */
	mov   sp, r2

	/*
	 * νARM¸Ǽ¹
	 */
	b     ret_exc

/*
 * ͥCPU㳰ν
 */
ALABEL(target_kernel_unc_exc_handler)
	/*
	 * ȯΥƥȤȽ
	 */
	ldr   r0, =excpt_nest_count /* 㳰ߥͥȲ */
	ldr   r1, [r0]
	add   r1, r1, #1
	str   r1, [r0]
	cmp   r1, #1
	bne   target_kernel_unc_exc_handler_1

	/* 
	 * ƥȤCPU㳰ȯ
	 * å󥿥ƥȤڤؤ롥
	 */
	ldr  r0, =_kernel_istkpt
	ldr  sp, [r0]

ALABEL(target_kernel_unc_exc_handler_1)
	stmfd sp!, {lr}  /* ѤΥåݥ󥿤¸ */
	
	/*
	 *  CPU㳰ϥɥεưϤ
	 */
	ldr   r0, =exch_tbl        /* CPU㳰ϥɥơ֥ɤ߽Ф */
	ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ */

   /*
	* ƥ֡ʥƥȤϽˤCPU㳰ȯξ֤
	*/
	ldr   r0, [r3,#(9*4)] /* CPU㳰ȯCPSRμ */
	and   r0, r0, #(CPSR_IRQ_BIT AOR CPSR_FIQ_BIT)
	orr   r0, r0, #(CPSR_SVC AOR CPSR_ALWAYS_SET)
	msr   cpsr_cxsf, r0

	/* 
	 * CPU㳰ϥɥθƤӽФ
	 * 㳰ե졼ƬȤϤ
	 */
	mov   r0, r3
	mov   lr, pc
	bx    r1

	/*
	 *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
	 */
	ldr   r0, =excpt_nest_count /* 㳰ߥͥȲ */
	ldr   r1, [r0]
	sub   r2, r1, #1
	str   r2, [r0]

	/*
	 * åݥ󥿤
	 */
	ldmfd sp!, {r2}    /* Υåݥ󥿤 */
	mov   sp, r2

	/*
	 * CPU㳰
	 */
	ldmfd sp!,{r0-r3,ip,lr}
	rfeia sp!
