/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_config.h 2480 2013-02-21 13:15:21Z ertl-honda $
 */

/*
 *  åװ¸⥸塼RMA1ѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_CHIP_CONFIG_H
#define TOPPERS_CHIP_CONFIG_H

#include "rma1.h"
#include "gic.h"

/*
 *  ߥϥɥֹȳֹ˴ؤ
 */
#define TMIN_INTNO  GIC_TMIN_INTNO 
#define TMAX_INTNO  GIC_TMAX_INTNO
#define TNUM_INT    GIC_TNUM_INT  

#define TMIN_INHNO  GIC_TMIN_INTNO 
#define TMAX_INHNO  GIC_TMAX_INTNO
#define TNUM_INH    GIC_TNUM_INT

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)    VALID_INTNO(intno)

/*
 *  ߥϥɥϿѥơ֥
 */
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 * 
 *  ߥϥɥֹinhnoγߥϥɥεưϤinthdrꤹ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
	assert(TMIN_INHNO <= inhno && inhno <= TMAX_INHNO);
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  ͥ٥ޥ饤֥PL390GICѡ
 *
 *  GICǤϡGICͥ٥쥸CPUγͥ٥ޥIPMˤꤹ롥  
 *  ͥ٥ޥͤ礭ۤͥ٤Ǥ롥
 *  ͥ٥ޥʳGICμΥѥ᡼ˤꡤ256,64,32,16 
 *  ǽǤ롥 
 * 
 *  IPM¸Ƥˡͥ٤γɽ-1Ϣ³͡
 *  ȤȤǽǤ뤬;פʷ׻ɬפˤʤ롥򤱤뤿ᡤIPM
 *  ¸ˤϡGICǰͥ٤ηȤ롥ͤͥ٥ޥ
 *  ɽȸƤӡIIPMȽ񤯤Ȥˤ롥 
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  㥹ȤʤѰդƤ롥
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)    ((PRI)(iipm - GICC_PMR_MASK))    /* ɽɽ */
#define INT_IPM(ipm)    ((uint8_t)(ipm + GICC_PMR_MASK))  /* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)    (iipm - GICC_PMR_MASK)           /* ɽɽ */
#define INT_IPM(ipm)    (ipm + GICC_PMR_MASK)             /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL        (INT_IPM(TIPM_ENAALL))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
	return(gicc_current_priority());
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{
	gicc_set_priority(iipm);
}

/*
 * (ǥ)ͥ٥ޥ
 */
Inline void
x_set_ipm(PRI intpri)
{
	set_iipm(INT_IPM(intpri));
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 */
Inline PRI
x_get_ipm(void)
{
	return(EXT_IPM(current_iipm()));
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ơ֥
 * 
 *  °ꤵƤ"1"ꤵƤʤ"0"Ȥʤ
 */
extern const uint8_t cfgint_tbl[TNUM_INT];

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥
 *    
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤  
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	if (cfgint_tbl[intno] == 0){
		return(false);
	}
    
	gicd_disable_int(intno);
	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 *  (ǥ)׵ػߥե饰β
 *
 *  ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 *  Ĥ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	if (cfgint_tbl[intno] == 0){
		return(false);
	}
	gicd_enable_int(intno);
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	gicd_clear_pending(intno);
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return(gicd_probe_int(intno));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 * ߥϥɥɬפIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{    
}

/*
 * ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  åװ¸ν
 */
extern void chip_initialize(void);

/*
 *  åװ¸νλ
 *
 *  ƥλ˻Ȥ
 */
extern void chip_exit(void);

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ARM¸⥸塼
 */
#include "arm_gcc/common/core_config.h"

#endif /* TOPPERS_CHIP_CONFIG_H */
