/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_serial.c 2485 2013-02-21 14:01:31Z ertl-honda $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СRMA1ѡ
 *  SCIF1  
 */

#include <kernel.h>
#include <t_syslog.h>
#include "chip_serial.h"

static INTNO const intno_sio[TNUM_SIOP] = { 
	INTNO_SIO_0,
	INTNO_SIO_1,
	INTNO_SIO_2,
	INTNO_SIO_3,
	INTNO_SIO_4,
	INTNO_SIO_5,
	INTNO_SIO_6,
	INTNO_SIO_7,
}; 

/* 
 *  ꥢI/OݡIDֹФΥޥ 
 */ 
#define INDEX_SIOP(siopid)           ((uint_t)((siopid) - 1)) 
#define get_intno_sio(siopid)        (intno_sio[INDEX_SIOP(siopid)]) 

/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	scif_initialize();    
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB    *p_siopcb;
	ER        ercd;

	/*
	 *  ꥢI/Oߤޥ롥
	 */
	ercd = dis_int(get_intno_sio(siopid));
	assert(ercd == E_OK);

	/*
	 *  ǥХ¸Υץ
	 */
	p_siopcb = scif_opn_por(siopid, exinf);

	/*
	 *  ꥢI/OߤΥޥ롥
	 */
	ercd = ena_int(get_intno_sio(siopid));
	assert(ercd == E_OK);

	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	ER ercd;
	ID siopid; 

	/* 
	 *  ꥢI/OݡIDμ 
	 */ 
	siopid = scif_get_siopid(p_siopcb);

	/*
	 *  ǥХ¸Υ
	 */
	scif_cls_por(p_siopcb);

	/*
	 *  ꥢI/Oߤޥ롥
	 */
	ercd = dis_int(intno_sio[siopid]);
	assert(ercd == E_OK);
}

/*
 *  SIOγߥϥɥ
 */
void
sio_isr(intptr_t exinf)
{
	scif_tx_isr(exinf);
	scif_rx_isr(exinf);
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char c)
{
	return(scif_snd_chr(siopcb, c));
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	return(scif_rcv_chr(siopcb));
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	scif_ena_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	scif_dis_cbr(siopcb, cbrtn);
}

/*
 *  ꥢI/OݡȤǽХå
 */
void
scif_irdy_snd(intptr_t exinf)
{
	sio_irdy_snd(exinf);
}

/*
 *  ꥢI/OݡȤμΥХå
 */
void
scif_irdy_rcv(intptr_t exinf)
{
	sio_irdy_rcv(exinf);
}
