/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_timer.c 2480 2013-02-21 13:15:21Z ertl-honda $
 */

/*
 *  ޥɥ饤СARM PrimeCell Timer Moduleѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

/*
 *  ޤΥåݻѿ
 *  chip_initialize() ǽ롥
 */
uint32_t timer_clock;

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	CLOCK    cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

	/*
	 *  ޼ꤷޤư򳫻Ϥ롥
	 */
	sil_wrb_mem((void*)TMU_TSTR,
				(sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR));  /*  */
	assert(cyc <= MAX_CLOCK);             /* ޾ͤΥå */

	sil_wrh_mem((void*)TMU_TCR, (TCR_UNIE | TCR_TPSC_4)); /* ʬꡢߵ */
	sil_wrw_mem((void*)TMU_TCOR, cyc); /* timer constant쥸򥻥å */
	sil_wrw_mem((void*)TMU_TCNT, cyc); /* 󥿡򥻥å */

	/* ׵򥯥ꥢ */
	sil_wrh_mem((void*)TMU_TCR,
				(sil_reh_mem((void*)TMU_TCR) & ~TCR_UNF));

	/* ޥ */
	sil_wrb_mem((void*)TMU_TSTR,
				(sil_reb_mem((void*)TMU_TSTR) | TMU_STR));
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	/* ޤ */
	sil_wrb_mem((void*)TMU_TSTR,
				(sil_reb_mem((void*)TMU_TSTR) & ~TMU_STR));
	/* ׵򥯥ꥢ */
	sil_wrh_mem((void*)TMU_TCR,0);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	/* ׵򥯥ꥢ */
	sil_wrh_mem((void*)TMU_TCR,
				(sil_reh_mem((void*)TMU_TCR) & ~TCR_UNF));
      
	i_begin_int(INTNO_TIMER);
	signal_time();                    /* ƥåζ */
	i_end_int(INTNO_TIMER);
}
