/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_timer.h 2480 2013-02-21 13:15:21Z ertl-honda $
 */

/*
 *  ޥɥ饤СTMUѡ
 *  ͥ0,1,2Τ줫
 */

#ifndef TOPPERS_CHIP_TIMER_H
#define TOPPERS_CHIP_TIMER_H

#include <sil.h>

/*
 * ޡ쥸
 */
#if USE_TMU_ID == 0
#define TMU_BASE  0xFFF80000
#define TMU_IRQ_BASE  (198 + 32)
#else /* USE_TMU_ID == 1 */
#define TMU_BASE  0xFFF90000
#define TMU_IRQ_BASE  (170 + 32)
#endif /* USE_TMU_ID == 0 */

#define TMU_TSTR  (TMU_BASE + 0x0004)  /* B */

#if USE_TMU_CH == 0
#define TMU_TCOR  (TMU_BASE + 0x0008)  /* W */
#define TMU_TCNT  (TMU_BASE + 0x000C)  /* W */
#define TMU_TCR   (TMU_BASE + 0x0010)  /* H */
#define TMU_STR   0x01
#define GIC_IRQNO_TMU (TMU_IRQ_BASE + 0)
#elif USE_TMU_CH == 1
#define TMU_TCOR  (TMU_BASE + 0x0014)  /* W */
#define TMU_TCNT  (TMU_BASE + 0x0018)  /* W */
#define TMU_TCR   (TMU_BASE + 0x001C)  /* H */
#define TMU_STR   0x02
#define GIC_IRQNO_TMU (TMU_IRQ_BASE + 1)
#elif USE_TMU_CH == 2
#define TMU_TCOR  (TMU_BASE + 0x0020)  /* W */
#define TMU_TCNT  (TMU_BASE + 0x0024)  /* W */
#define TMU_TCR   (TMU_BASE + 0x0028)  /* H */
#define TMU_STR   0x04
#define GIC_IRQNO_TMU (TMU_IRQ_BASE + 2)
#else /* USE_TMU_CH == 2 */
#error
#endif /* USE_TMU_CH == 0 */

/*
 *  TCRΥӥå
 */
#define TCR_UNF        0x0100
#define TCR_UNIE       0x0020
#define TCR_TPSC_4     0x0000
#define TCR_TPSC_16    0x0001
#define TCR_TPSC_64    0x0002
#define TCR_TPSC_256   0x0003
#define TCR_TPSC_1024  0x0004

/*
 *  ޳ߥϥɥϿΤ
 */
#define INHNO_TIMER     GIC_IRQNO_TMU /* ߥϥɥֹ */
#define INTNO_TIMER     GIC_IRQNO_TMU /* ֹ */

#ifndef INTPRI_TIMER
#define INTPRI_TIMER    -6            /* ͥ */
#endif /* INTPRI_TIMER */

#define INTATR_TIMER    0U            /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  ޤΥåݻѿ  
 */
extern uint32_t timer_clock;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 */
#define TO_CLOCK(nume, deno) (timer_clock * (nume) / (deno))
#define TO_USEC(clock)       (((SYSUTM) clock) * 1000U / timer_clock)


/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK        ((CLOCK) 0xffffffffU)

/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE    100U    /* ٤θѤ͡ñ̤ɽ*/
#define BEFORE_IREQ(clock) \
            ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void    target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void    target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	return(TO_CLOCK(TIC_NUME, TIC_DENO) - sil_rew_mem((void*)TMU_TCNT));
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
	return(sil_reh_mem((void*)TMU_TCR) & TCR_UNF);
}

/*
 *  ޳ߥϥɥ
 */
extern void    target_timer_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CHIP_TIMER_H */
