/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2011 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: scif.h 2485 2013-02-21 14:01:31Z ertl-honda $
 */

/*
 *   SH SCIF ʰSIOɥ饤
 */

#ifndef TOPPERS_SCIF_H
#define TOPPERS_SCIF_H

#ifndef TOPPERS_MACRO_ONLY

#include <kernel.h>

/*
 *  ꥢSIOΥݡȿ
 */
#define TNUM_SIOP  8

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND    1U        /* ǽХå */
#define SIO_RDY_RCV    2U        /* ΥХå */

/*
 *  SIOɥ饤Фν롼
 */
extern void scif_initialize(void);

/*
 * ͥ뵯ưΥСʽѤν
 */
extern void scif_init(ID siopid);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void scif_pol_putc(char c, ID siopid);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern bool_t scif_openflag_id(ID siopid);			/*  ݡID  */
extern bool_t scif_openflag_cb(SIOPCB *p_siopcb);	/*  ֥åƬ  */

/* 
 *  ݡIDμ 
 */ 
extern ID scif_get_siopid(SIOPCB *p_siopcb);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *scif_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void scif_cls_por(SIOPCB *p_siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t scif_snd_chr(SIOPCB *p_siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t scif_rcv_chr(SIOPCB *p_siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void  scif_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void scif_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void scif_tx_isr(ID siopid);
extern void scif_rx_isr(ID siopid);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void scif_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void scif_irdy_rcv(intptr_t exinf);


/*
 *  ݡֹ椫֥åƬϤؤѴ
 */
extern SIOPCB *scif_get_siopcb(ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_SCIF_H */
