/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2012-2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: safeg_load.c 2480 2013-02-21 13:15:21Z ertl-honda $
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>

bool_t run_trust;
SYSUTM trust_start_time;
SYSUTM trust_total_time;
SYSUTM load_start_time;

/*
 *  
 */
void
safeg_load_init(intptr_t exinf)
{
	run_trust = true;

	if (sns_ker()) {
		/* J[lNO */
		trust_start_time = 0;
		load_start_time = 0;
	}
	else {
		/* J[lN */
		get_utm(&trust_start_time);
		load_start_time = trust_start_time;
	}

	trust_total_time = 0;
}

/*
 *  CPUp̎擾
 */
void
safeg_load_info(uint32_t *p_trust_load, uint32_t *p_nontrust_load)
{
	SYSUTM cur_time;
	SYSUTM trust_total;

	get_utm(&cur_time);
	trust_total = trust_total_time + (cur_time - trust_start_time);

	*p_trust_load = (trust_total/10)/((cur_time - load_start_time)/1000);
	*p_nontrust_load = 100 - *p_trust_load;
}

/*
 *  ݂̓ŌĂяo֐
 */
void
safeg_load_int(void){
	if (!run_trust) {
		run_trust = true;
		get_utm(&trust_start_time);
	}
}

/*
 *  AChɌĂяo֐
 */
void
safeg_load_idle(void){
	SYSUTM time;

	run_trust = false;
	get_utm(&time);
	trust_total_time += time - trust_start_time;
}
