/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 2485 2013-02-21 14:01:31Z ertl-honda $
 */

/*
 * åȰ¸⥸塼ARMADILLO-800-EVAѡ
 */
#include "kernel_impl.h"
#include <sil.h>
#include "arm.h"
#include "scif.h"

#if defined(TOPPERS_SAFEG_SECURE) && defined(TOPPERS_SAFEG_LOAD)
#include "safeg_load.h"
#endif /* defined(TOPPERS_SAFEG_SECURE) && defined(TOPPERS_SAFEG_LOAD) */

/*
 * Υ١ɥ쥹ȥ
 */
#define SDRAM_ADDR 0x40000000
#define SDRAM_SIZE (512 * 1024 * 1024)

void
target_mmu_init(void){
	MEMORY_ATTRIBUTE m_attribute;

	/*
	 * ʪɥ쥹 = ۥɥ쥹
	 * Υ󥭥å֥롤ΥХåե֥Ȥ 
	 */
	m_attribute.pa   = 0x00000000;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = 0x80000000;
	m_attribute.s    = 1;          /* ͭ         */
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 0;          /* Strongly Ordered */
	m_attribute.c    = 0;
	m_attribute.b    = 0;

	mmu_map_memory (&m_attribute);

	m_attribute.pa   = 0x80000000;
	m_attribute.va   = m_attribute.pa;

	mmu_map_memory (&m_attribute);
	
	/*
	 *  SDRAM
	 */
	m_attribute.pa   = SDRAM_ADDR;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = SDRAM_SIZE;
//	m_attribute.s    = 1;          /* ͭ         */
	m_attribute.s    = 0;          /* ͭ       */
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 1;          /* Outer and Inner */
	m_attribute.c    = 1;          /* Inner Write-Back, Write Allocate */ 
	m_attribute.b    = 1;

	mmu_map_memory(&m_attribute);

#if !defined(TOPPERS_SAFEG_SECURE) && !defined(TOPPERS_SAFEG_NONSECURE)
	/*
	 *  ٥ơ֥0x0000֤ᡤSDRAM
	 *  0x00001MByte֤ 
	 */
	m_attribute.pa   = SDRAM_ADDR;
	m_attribute.va   = 0x00000000;   
	m_attribute.size = 0x00100000; /* 1MB */
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 1;          /* Outer and Inner */
	m_attribute.c    = 1;          /* Inner Write-Back, Write Allocate */ 
	m_attribute.b    = 1;

	mmu_map_memory(&m_attribute);
#endif /* !defined(TOPPERS_SAFEG_SECURE) && !defined(TOPPERS_SAFEG_NONSECURE) */

#ifdef TOPPERS_SAFEG_COM
	/*
	 *  OS̿Τγդ
	 */
	m_attribute.pa   = SAFEG_COM_MEM_ADDR;
	m_attribute.va   = m_attribute.pa;
	m_attribute.size = SAFEG_COM_MEM_SIZE * 1024 * 1024;
	m_attribute.ns   = 1;          /* NonSecure    */
	m_attribute.s    = 0;          /* ͭʤ     */
	m_attribute.ap   = 3;          /* ե륢 */
	m_attribute.tex  = 0;          /* åON */
	m_attribute.c    = 1;          /* Outer and Inner */          
	m_attribute.b    = 1;          /* Inner Write-Back, Write Allocate */ 

	mmu_map_memory(&m_attribute);
#endif /* TOPPERS_SAFEG_COM */
}

/*
 *  ԥե󥯥
 */
void
pfc_init(void)
{
	/* SCIF0ͭ */
	sil_wrb_mem((uint8_t *)0xE60520C5, 0x11);
	sil_wrb_mem((uint8_t *)0xE60520C6, 0xD1);
    
	/* SCIF1ͭ */
	sil_wrb_mem((uint8_t *)0xE60520C3, 0x11);
	sil_wrb_mem((uint8_t *)0xE60520C4, 0xD1);    
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/* high vectorѤʤ褦 */
	set_high_vector(false);
	
	/*
	 * ߥȥȤGICѤ(INTA_CTRL)
	 */
	sil_wrw_mem((void *)(0xE605807C),
				(sil_rew_mem((void *)(0xE605807C)) & ~0x00000002));
    
#if USE_TMU_ID == 0
	/* TMU0λѳ */
	sil_wrw_mem((void*)0xE6150134,
				(sil_rew_mem((void*)0xE6150134) & ~0x02000000));
#endif /* USE_TMU_ID == 0 */
    
#if USE_TMU_ID == 1
	/* TMU1λѳ */
	sil_wrw_mem((void*)0xE6150134,
				(sil_rew_mem((void*)0xE6150134) & ~(1 << 11)));
#endif /* USE_TMU_ID == 1 */
	
	/*
	 * åװ¸ν
	 */
	chip_initialize();

	/* ԥե󥯥󥳥ȥ */
	pfc_init();
    
	/*
	 *  ٥ѤUART
	 */
	scif_init(USE_SIO_PORTID);

#if defined(TOPPERS_SAFEG_SECURE) || defined(TOPPERS_SAFEG_NONSECURE)
	/*
	 * ߥ٥ơ֥ VECTOR_TABLE_BASE 쥸ꤹ
	 */
	extern void *vector_table;
	CP15_SET_VBAR((uint32_t) &vector_table);
#endif /* defined(TOPPERS_SAFEG_SECURE) || defined(TOPPERS_SAFEG_NONSECURE) */

#if defined(TOPPERS_SAFEG_SECURE) && defined(TOPPERS_SAFEG_LOAD)
	safeg_load_init(0);
#endif /* defined(TOPPERS_SAFEG_SECURE) && defined(TOPPERS_SAFEG_LOAD) */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	/*
	 *  åװ¸νλ
	 */
	chip_exit();

	while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char c)
{
	if (c == '\n') {
		scif_pol_putc('\r', USE_SIO_PORTID);
	}
	scif_pol_putc(c, USE_SIO_PORTID);
}
