/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 2480 2013-02-21 13:15:21Z ertl-honda $
 */

/*
 *  åװ¸⥸塼ARMADILLO-800-EVAѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȰ¸Υϡɥ񸻤
 */
#include "armadillo-800-eva.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#ifdef TOPPERS_SAFEG_SECURE
/*
 *  CPUåǥåȤӥå
 */
#define CPSR_CPULOCK     (CPSR_FIQ_BIT|CPSR_IRQ_BIT)

/*
 *  CPSR˾˥åȤѥ
 */
#define CPSR_ALWAYS_SET  CPSR_IRQ_BIT

/*
 *  ߤFIQȤư
 */
#define GIC_USE_FIQ

/*
 *  TOPPERS_CUSTOM_IDLE ͭ
 */
#define TOPPERS_CUSTOM_IDLE

/*
 *  ɥμ¹ԥ
 */
#ifdef TOPPERS_SAFEG_LOAD
#define toppers_asm_custom_idle  bl  safeg_load_idle; mov r0, #0; smc 0;
#else /* !TOPPERS_SAFEG_LOAD */
#define toppers_asm_custom_idle  mov r0, #0; smc 0
#endif /* TOPPERS_SAFEG_LOAD */

#endif /* TOPPERS_SAFEG_SECURE */

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ  0x2000U /* 8Kbyte */

/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    20
#define SIL_DLY_TIM2    10

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 * ޥåפνchip¸ƤӽФ
 * Ʊ˥åͭˤ
 */
extern void target_mmu_init(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  åװ¸⥸塼RMA1ѡ
 */
#include "arm_gcc/rma1/chip_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
